/* src/PNotifyAnimateComponent.html generated by Svelte v3.18.2 */
import { SvelteComponent, init, safe_not_equal } from "svelte/internal";

const key = "Animate";

const defaults = {
	// Use animate.css to animate the notice.
	animate: false,
	// The class to use to animate the notice in.
	inClass: "",
	// The class to use to animate the notice out.
	outClass: ""
};

function instance($$self, $$props, $$invalidate) {
	let { self = null } = $$props;
	let { animate = defaults.animate } = $$props;
	let { inClass = defaults.inClass } = $$props;
	let { outClass = defaults.outClass } = $$props;
	let _animateIn;
	let _animateOut;
	let _animation;

	self.on("pnotify:update", () => {
		if (animate && self.refs.elem) {
			var animSpeed = 250;

			if (self.animateSpeed === "slow") {
				animSpeed = 400;
			} else if (self.animateSpeed === "fast") {
				animSpeed = 100;
			} else if (self.animateSpeed > 0) {
				animSpeed = self.animateSpeed;
			}

			animSpeed = animSpeed / 1000;

			if (self.refs.elem.style.animationDuration !== animSpeed + "s") {
				$$invalidate(0, self.refs.elem.style.animationDuration = animSpeed + "s", self);
			}
		}
	});

	function animateIn(callback, immediate) {
		// Declare that the notice is animating in.
		self.setAnimating("in");

		let off;

		const finished = event => {
			if (event && self.refs.elem && event.target !== self.refs.elem) {
				return;
			}

			off();
			self.setAnimatingClass("ui-pnotify-in animated");

			if (callback) {
				callback.call();
			}

			// Declare that the notice has completed animating.
			self.setAnimating(false);
		};

		off = self.on("animationend", finished);

		if (immediate) {
			finished();
		} else {
			self.setAnimatingClass("ui-pnotify-in animated " + inClass);
		}
	}

	function animateOut(callback, immediate) {
		// Declare that the notice is animating out.
		self.setAnimating("out");

		let off;

		const finished = event => {
			if (event && self.refs.elem && event.target !== self.refs.elem) {
				return;
			}

			off();
			self.setAnimatingClass("animated");

			if (callback) {
				callback.call();
			}

			// Declare that the notice has completed animating.
			if (self.setAnimating) {
				self.setAnimating(false);
			}
		};

		off = self.on("animationend", finished);

		if (immediate) {
			finished();
		} else {
			self.setAnimatingClass("ui-pnotify-in animated " + outClass);
		}
	}

	self.attention = (aniClass, callback) => {
		let off;

		const cb = () => {
			off();
			self.removeModuleClass("container", "animated", aniClass);

			if (callback) {
				callback.call(self);
			}
		};

		off = self.on("animationend", cb);
		self.addModuleClass("container", "animated", aniClass);
	};

	$$self.$set = $$props => {
		if ("self" in $$props) $$invalidate(0, self = $$props.self);
		if ("animate" in $$props) $$invalidate(1, animate = $$props.animate);
		if ("inClass" in $$props) $$invalidate(2, inClass = $$props.inClass);
		if ("outClass" in $$props) $$invalidate(3, outClass = $$props.outClass);
	};

	$$self.$$.update = () => {
		if ($$self.$$.dirty & /*animate, _animateIn, self, _animation, _animateOut*/ 115) {
			$: {
				if (animate && !_animateIn) {
					$$invalidate(6, _animation = self.animation);
					$$invalidate(4, _animateIn = self.animateIn);
					$$invalidate(5, _animateOut = self.animateOut);
					self.$set({ animation: "none", animateIn, animateOut });
				} else if (!animate && _animateIn) {
					self.$set({
						animation: _animation,
						animateIn: _animateIn,
						animateOut: _animateOut
					});

					$$invalidate(6, _animation = null);
					$$invalidate(4, _animateIn = null);
					$$invalidate(5, _animateOut = null);
				}
			}
		}
	};

	return [self, animate, inClass, outClass];
}

class PNotifyAnimateComponent extends SvelteComponent {
	constructor(options) {
		super();

		init(this, options, instance, null, safe_not_equal, {
			self: 0,
			animate: 1,
			inClass: 2,
			outClass: 3
		});
	}
}

export default PNotifyAnimateComponent;
export { key, defaults };
//# sourceMappingURL=PNotifyAnimateComponent.js.map