/* src/PNotifyMobileComponent.html generated by Svelte v3.18.2 */
import {
	SvelteComponent,
	globals,
	init,
	listen,
	noop,
	safe_not_equal
} from "svelte/internal";

const { window: window_1 } = globals;
import PNotify from "./PNotifyCore";

function create_fragment(ctx) {
	let dispose;

	return {
		c: noop,
		m(target, anchor) {
			dispose = listen(window_1, "resize", /*windowResize*/ ctx[0]);
		},
		p: noop,
		i: noop,
		o: noop,
		d(detaching) {
			dispose();
		}
	};
}

const key = "Mobile";

const defaults = {
	// Let the user swipe the notice away.
	swipeDismiss: true,
	// Styles the notice to look good on mobile.
	styling: true
};

function instance($$self, $$props, $$invalidate) {
	let { self = null } = $$props;
	let { swipeDismiss = defaults.swipeDismiss } = $$props;
	let { styling = defaults.styling } = $$props;
	let origXY = null;
	let diffXY = null;
	let noticeWidthHeight = null;
	let noticeOpacity = null;
	let csspos = "left";
	let direction = "X";
	let span = "Width";
	let windowInnerWidth = window.innerWidth;

	self.on("touchstart", e => {
		if (!swipeDismiss) {
			return;
		}

		const stack = self.stack;

		if (stack) {
			switch (stack.dir1) {
				case "up":
				case "down":
					csspos = "left";
					direction = "X";
					span = "Width";
					break;
				case "left":
				case "right":
					csspos = "top";
					direction = "Y";
					span = "Height";
					break;
			}
		}

		origXY = e.touches[0]["screen" + direction];
		noticeWidthHeight = self.refs.elem["scroll" + span];
		noticeOpacity = window.getComputedStyle(self.refs.elem)["opacity"];
		$$invalidate(1, self.refs.container.style[csspos] = 0, self);
	});

	self.on("touchmove", e => {
		if (!origXY || !swipeDismiss) {
			return;
		}

		const curXY = e.touches[0]["screen" + direction];
		diffXY = curXY - origXY;
		const opacity = (1 - Math.abs(diffXY) / noticeWidthHeight) * noticeOpacity;
		$$invalidate(1, self.refs.elem.style.opacity = opacity, self);
		$$invalidate(1, self.refs.container.style[csspos] = diffXY + "px", self);
	});

	self.on("touchend", () => {
		if (!origXY || !swipeDismiss) {
			return;
		}

		self.refs.container.classList.add("ui-pnotify-mobile-animate-left");

		if (Math.abs(diffXY) > 40) {
			const goLeft = diffXY < 0
			? noticeWidthHeight * -2
			: noticeWidthHeight * 2;

			$$invalidate(1, self.refs.elem.style.opacity = 0, self);
			$$invalidate(1, self.refs.container.style[csspos] = goLeft + "px", self);
			self.close();
		} else {
			self.refs.elem.style.removeProperty("opacity");
			self.refs.container.style.removeProperty(csspos);
		}

		origXY = null;
		diffXY = null;
		noticeWidthHeight = null;
		noticeOpacity = null;
	});

	self.on("touchcancel", () => {
		if (!origXY || !swipeDismiss) {
			return;
		}

		self.refs.elem.style.removeProperty("opacity");
		self.refs.container.style.removeProperty(csspos);
		origXY = null;
		diffXY = null;
		noticeWidthHeight = null;
		noticeOpacity = null;
	});

	self.on("pnotify:afterClose", () => {
		// Remove any styling we added to close it.
		if (!swipeDismiss) {
			return;
		}

		self.refs.elem.style.removeProperty("opacity");
		self.refs.container.style.removeProperty("left");
		self.refs.container.style.removeProperty("top");
	});

	function windowResize() {
		$$invalidate(11, windowInnerWidth = window.innerWidth);
	}

	$$self.$set = $$props => {
		if ("self" in $$props) $$invalidate(1, self = $$props.self);
		if ("swipeDismiss" in $$props) $$invalidate(2, swipeDismiss = $$props.swipeDismiss);
		if ("styling" in $$props) $$invalidate(3, styling = $$props.styling);
	};

	$$self.$$.update = () => {
		if ($$self.$$.dirty & /*self, styling, windowInnerWidth*/ 2058) {
			$: {
				const stack = self.stack;

				if (styling && !self.hasModuleClass("elem", "ui-pnotify-mobile-able")) {
					if (stack) {
						if (windowInnerWidth <= 480) {
							if (!stack.mobileOrigSpacing1) {
								stack.mobileOrigSpacing1 = stack.spacing1;
							}

							stack.spacing1 = 0;

							if (!stack.mobileOrigFirstpos1) {
								stack.mobileOrigFirstpos1 = stack.firstpos1;
							}

							stack.firstpos1 = 0;

							if (!stack.mobileOrigSpacing2) {
								stack.mobileOrigSpacing2 = stack.spacing2;
							}

							stack.spacing2 = 0;

							if (!stack.mobileOrigFirstpos2) {
								stack.mobileOrigFirstpos2 = stack.firstpos2;
							}

							stack.firstpos2 = 0;
						} else {
							if (stack.mobileOrigSpacing1) {
								stack.spacing1 = stack.mobileOrigSpacing1;
								delete stack.mobileOrigSpacing1;
							}

							if (stack.mobileOrigFirstpos1) {
								stack.firstpos1 = stack.mobileOrigFirstpos1;
								delete stack.mobileOrigFirstpos1;
							}

							if (stack.mobileOrigSpacing2) {
								stack.spacing2 = stack.mobileOrigSpacing2;
								delete stack.mobileOrigSpacing2;
							}

							if (stack.mobileOrigFirstpos2) {
								stack.firstpos2 = stack.mobileOrigFirstpos2;
								delete stack.mobileOrigFirstpos2;
							}
						}

						self.removeModuleClass("elem", "ui-pnotify-mobile-top", "ui-pnotify-mobile-bottom", "ui-pnotify-mobile-right", "ui-pnotify-mobile-left");

						switch (stack.dir1) {
							case "down":
								self.addModuleClass("elem", "ui-pnotify-mobile-top");
								break;
							case "up":
								self.addModuleClass("elem", "ui-pnotify-mobile-bottom");
								break;
							case "left":
								self.addModuleClass("elem", "ui-pnotify-mobile-right");
								break;
							case "right":
								self.addModuleClass("elem", "ui-pnotify-mobile-left");
								break;
						}
					}

					self.addModuleClass("elem", "ui-pnotify-mobile-able");
				} else if (!styling && self.hasModuleClass("elem", "ui-pnotify-mobile-able")) {
					self.removeModuleClass("elem", "ui-pnotify-mobile-able", "ui-pnotify-mobile-top", "ui-pnotify-mobile-bottom", "ui-pnotify-mobile-right", "ui-pnotify-mobile-left");

					if (stack) {
						if (stack.mobileOrigSpacing1) {
							stack.spacing1 = stack.mobileOrigSpacing1;
							delete stack.mobileOrigSpacing1;
						}

						if (stack.mobileOrigFirstpos1) {
							stack.firstpos1 = stack.mobileOrigFirstpos1;
							delete stack.mobileOrigFirstpos1;
						}

						if (stack.mobileOrigSpacing2) {
							stack.spacing2 = stack.mobileOrigSpacing2;
							delete stack.mobileOrigSpacing2;
						}

						if (stack.mobileOrigFirstpos2) {
							stack.firstpos2 = stack.mobileOrigFirstpos2;
							delete stack.mobileOrigFirstpos2;
						}
					}
				}
			}
		}
	};

	return [windowResize, self, swipeDismiss, styling];
}

class PNotifyMobileComponent extends SvelteComponent {
	constructor(options) {
		super();
		init(this, options, instance, create_fragment, safe_not_equal, { self: 1, swipeDismiss: 2, styling: 3 });
	}
}

export default PNotifyMobileComponent;
export { key, defaults };
//# sourceMappingURL=PNotifyMobileComponent.js.map